{
  TUTOR1.PAS

  a very first example
}

uses dos, crt, _VidKRNL, _VID111, _XLSP111;

var
  sonicGFX : TSprite; { this is a sprite }
  sonicPAL : TPal;    { this is a 256 color palette }
  virtualPage : TPage111h; {this is a virtual Page}

begin
  { initialise the Video111h variables. Call this procedure first }
  InitVideo111h;

  { load the Sonic-Palette palette }
  LoadPalette( '.\PAL\SONIC.PAL' , sonicPAL );

  { loads SONIC1-1.CLB to the sonicGFX sprite }
  LoadImprocesCLB( '.\GFX\SONIC1-1.CLB' , sonicGFX , sonicPAL);

  InitPage111h( VirtualPage );

  { switch on the 640x480x64k Mode }
  SetVideoMode111h( Mode111h );

  { all outputs go to the VirtualPage}
  ActivePage111H( VirtualPage );

  { now we draw the Sprite sonicGFX to the point 0,0 of VirtualPage. The
    reference Point 0,0 is the upper left point of the sprite.
    The Window means that it recognizes borders set before with
    SetWindow( x1,y1 ,x2,y2) [ (x1, y1) upper left point of the window,
    (x2, y2) bottom right point of the window ].

    Screen definition:

    0, 0
      +-----------------------+
      !                       !
      !                       !
      !                       !
      !                       !
      !                       !
      !                       !
      +-----------------------+
                           639, 399

    }
  PutSpriteWindow111h( 0, 0, sonicGFX );

  { Equal to PutSpriteWindow111h, except that you have to give a parameter
    for a transparent color. This color won't be drawn on the screen, so
    you have the facility to draw transparent sprites.
    So the following procedure will draw the sonicGFX to 0,0 of the
    VirtualPage with the transparent color 0 }
  PutSpriteWindowTrans111h( 10, 15, 0, sonicGFX );

  CopyP2V111h(virtualPage);

  repeat until keypressed; { wait for a key pressed }

  { gives the sprite memory back to system }
  CloseSprite( sonicGFX );

  ClosePage111h( virtualPage );

  { switch back to normal text mode 80x25 }
  SetVideoMode111h( Mode3h );

  { Closes the Video111h. Should be the last instruction in your programm }
  CloseVideo111h;
end.