{ TUTOR8.PAS

  How to do Light effects?

  Great example of PutSpriteWindowAdd(x,y,sprite)

  Sorry, but we intend to use this file for a demo, but
  than we decided to release the source, so there aren't
  any further information in the code.

}


uses dos, crt, _VidKRNL,_Vid111, _XLSP111;

const
  MaxStar=50; { Number of stars }

var
  VirtualPage:TPage111h; { Just a virtual page }

  vtlogoGFX : TSprite;   { just a simple sprite }
  starGFX   : TSprite;   { just a simple sprite }
  vtBackGFX : TXLSprite; { a XL-Sprite, > 64 kb }

  sinTab : array[1..2,0..255] of integer; { sinus-values table }

  sinStartX, SinPosX : byte;
  sinStartY, SinPosY : byte;

  starx,
  stary : array[ 1 .. MaxStar ] of integer; { stars x and y coordinate }

  star : integer;

  starx1,
  stary1 : integer;

  starD : integer;

  scalex,
  scaley : integer;

  scalexspeed,
  scaleyspeed : integer;

  r1, r2 : byte;

  x1,x2,
  zielx,
  y : integer;

{ create a sin table }
procedure makeSinTab;
begin
  starx1 := 320 - starGFX.b div 2;
  stary1 := 240 - starGFX.t div 2;
  Randomize;
  r1:=1;
  r2:=3;
  for sinPosX:=0 to 255 do
    begin
      {x}
      sinTab[ 1, sinPosX ] := round( sin( ( 2 * pi / 255 ) * r1 *
                              sinPosX ) * starX1 );
      {y}
      sinTab[ 2, sinPosX ] := round( sin( ( 2 * pi / 255 ) * r2 *
                              sinPosX ) * starY1 );
    end;
end;

begin
  InitVideo111h;
  InitPage111h( VirtualPage );

  SetVideoMode111h( Mode111h );

  loadTGA2Sprite( '.\GFX\vtlogo1.TGA', vtLogoGFX );
  loadTGA2Sprite( '.\GFX\star3.TGA', starGFX );
  loadTGA2XLSprite( '.\GFX\star4.TGA', vtBackGFX );

  makeSinTab;
  starD := 255 div maxStar;

  sinStartX := 0;
  sinStartY := 0;

  inc( sinStartX );
  inc( sinStartY, 2 );

  SinPosX := SinStartX;
  SinPosY := SinStartY;

  for star := 1 to MaxStar do
    begin
      starx[star]:=starX1+sinTab[1,sinPosX];
      stary[star]:=starY1+sinTab[2,sinPosY];
      inc(sinPosX,starD);
      inc(sinPosY,starD);
    end;

  y  := 90;
  x1 := -vtLogoGFX.b;
  x2 := 320 - ( vtLogoGFX.b div 2 ) + 320 + vtLogoGFX.b div 2;
  zielx := 320 - ( vtLogoGFX.b div 2 );

  scalex := 10;
  scaley := 20;
  scalexspeed := 8;
  scaleyspeed := 5;

  repeat
    putXLSpriteWindow111h(   0,   0, vtBackGFX );
    putXLSpriteWindow111h( 320,   0, vtBackGFX );
    putXLSpriteWindow111h(   0, 200, vtBackGFX );
    putXLSpriteWindow111h( 320, 200, vtBackGFX );
    putXLSpriteWindow111h(   0, 400, vtBackGFX );
    putXLSpriteWindow111h( 320, 400, vtBackGFX );

    if ( scalex > 300 ) or ( scalex < 10 ) then
      scalexspeed := - scalexspeed;
    if ( scaley > 150 ) or ( scaley < 10 ) then
      scaleyspeed := - scaleyspeed;

    scalex := scalex + scalexspeed;
    scaley := scaley + scaleyspeed;

    { 23,0,0 are the lightning red, green and blue values }
    putSpriteWindowLight111h( x1, y, 23, 00, 00, vtLogoGFX );
    putSpriteWindowLight111h( x2, y, 23, 00, 00, vtLogoGFX );

    { putSpriteScaledTrans111h( 320 - scalex, 240 - scaley,
                              320 + scalex, 240 + scaley,
                              0, vtLogoGFX );

     Not available here...
    }

    for star := 1 to MaxStar do
      putSpriteWindowAdd111h( starx[ star ], stary[ star ], starGFX );

    Retrace;

    copyP2V111h( virtualPage );
    dec( x2, 4 );
    inc( x1, 4 );
    if x1 > zielx then
      begin
        x1 := zielx;
        x2 := zielx;
      end;

    inc( sinStartX, 1 );
    inc( sinStartY, 2 );

    SinPosX := SinStartX;
    SinPosY := SinStartY;

    for star := 1 to MaxStar do
      begin
        starx[ star ] := starX1 + sinTab[ 1, sinPosX ];
        stary[ star ] := starY1 + sinTab[ 2, sinPosY ];
        inc( sinPosX, starD );
        inc( sinPosY, starD );
      end;
  until keypressed;
  while keypressed do readkey;

  CloseXLSprite( vtBackGFX );
  closeSprite( vtLogoGFX );
  closeSprite( starGFX );

  closepage111h( virtualPage );

  SetVideoMode111h( Mode3h );

  CloseVideo111h;
  writeln('Bye...');
end.